function T = solveR_T1_T2(I,A,B,C,D,k,k0)
    global nu G rhoi rhow g h H w 
    if k0*H>8.e2
        H = 8.e2/k0;  % prevent blow up as sinh(x), where x = k0*H is too large
    end
% M*T = F => T = inv(M'*M)*M'*F
    ve = nu + 1i*G/rhoi/w;
    a  = sqrt(k.^2 - 1i*w/ve);
    F  = [ -I*1i*g*sinh(k0*H)/(k0*w*cosh(k0*(h+H)))
          -I*g*sinh(k0*H)/(w*cosh(k0*(h+H)))
          -I*rhow*g/k0*(sinh(k0*(h+H)) - sinh(k0*H))/cosh(k0*(h+H))
          -I*g*(sinh(k0*(h+H)) - sinh(k0*H))/(w*cosh(k0*(h+H)))];

    M(1,1) = 1i*g*sinh(k0*H)/(k0*w*cosh(k0*(h+H)));
    M(1,2) = -(B(1) - 1i*C(1))/k(1); % be consistent with Wang's program, it's an additional '-'
    M(1,3) = -(B(2) - 1i*C(2))/k(2); % than that in their 2011 paper.
    M(2,1) = -g*sinh(k0*H)/(w*cosh(k0*(h+H)));
    M(2,2) = 1i*B(1) + C(1);
    M(2,3) = 1i*B(2) + C(2);
    M(3,1) = rhow*g/k0*(sinh(k0*(h+H))-sinh(k0*H))/cosh(k0*(h+H));
    M(3,2) = A(1)*(1i*rhoi*w/k(1)+2*rhoi*ve*k(1))*sinh(k(1)*h) ...
           + B(1)*(1i*rhoi*w/k(1)+2*rhoi*ve*k(1))*(cosh(k(1)*h)-1) ...
           + C(1)*(2*1i*rhoi*ve*k(1)*(1-cosh(a(1)*h)))...
           + D(1)*(-2*1i*rhoi*ve*k(1)*sinh(a(1)*h));

    M(3,3) = A(2)*(1i*rhoi*w/k(2)+2*rhoi*ve*k(2))*sinh(k(2)*h) ...
           + B(2)*(1i*rhoi*w/k(2)+2*rhoi*ve*k(2))*(cosh(k(2)*h)-1) ...
           + C(2)*(2*1i*rhoi*ve*k(2)*(1-cosh(a(2)*h)))...
           + D(2)*(-2*1i*rhoi*ve*k(2)*sinh(a(2)*h));
    M(4,1) = -g*(sinh(k0*(h+H))-sinh(k0*H))/(w*cosh(k0*(h+H)));
    M(4,2) = 1i*(A(1)*sinh(k(1)*h) + B(1)*(cosh(k(1)*h)-1)) ...
           + C(1)*(cosh(a(1)*h)-1) + D(1)*sinh(a(1)*h);
    M(4,3) = 1i*(A(2)*sinh(k(2)*h) + B(2)*(cosh(k(2)*h)-1)) ...
           + C(2)*(cosh(a(2)*h)-1) + D(2)*sinh(a(2)*h);
% M*T = F => T = inv(M'*M)*M'*F
    T = (M'*M)\(M'*F); % T = [R,T1,T2]
end
    
    
